## crystal-facet-uml 1.38.0

=== CMakeLists.txt ===
PROJECT(crystal-facet-uml LANGUAGES C)
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)

#helper to find include directories and libraries:
FIND_PACKAGE(PkgConfig REQUIRED)

# ==== ==== ==== ==== ==== ==== ==== ==== Build Environment Settings ==== ==== ==== ==== ==== ==== ==== ====

SET(COMPILE_IN_INCLUDE_DIR "" CACHE FILEPATH "Path to additional include directory")
SET(COMPILE_IN_SOURCE_FILE "" CACHE FILEPATH "Path to additional source file, e.g. sqlite3.c")
INCLUDE_DIRECTORIES(${COMPILE_IN_INCLUDE_DIR})

# crystal-facet-uml

INCLUDE_DIRECTORIES(gui/include)
INCLUDE_DIRECTORIES(main/include)
INCLUDE_DIRECTORIES(ctrl/include)
INCLUDE_DIRECTORIES(data/include)
INCLUDE_DIRECTORIES(u8buf/include)
INCLUDE_DIRECTORIES(pencil/include)
INCLUDE_DIRECTORIES(io/include)
INCLUDE_DIRECTORIES(u8stream/include)

#sqlite3 dependencies

PKG_SEARCH_MODULE(SQLITE3 REQUIRED sqlite3)
INCLUDE_DIRECTORIES(${SQLITE3_INCLUDE_DIRS})
#MESSAGE("SQLITE3: ${SQLITE3_INCLUDE_DIRS}")

#gtk dependencies
PKG_SEARCH_MODULE(GLIB2 REQUIRED glib-2.0)
INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
#MESSAGE("GLIB2:   ${GLIB2_INCLUDE_DIRS}")

PKG_SEARCH_MODULE(GTK REQUIRED gtk+-3.0)
#PKG_SEARCH_MODULE(GTK REQUIRED gtk4)
INCLUDE_DIRECTORIES(${GTK_INCLUDE_DIRS})
MESSAGE("GTK:    ${GTK_INCLUDE_DIRS}")
MESSAGE("GTK:    ${GTK_FOUND}")
MESSAGE("GTK:    ${GTK_LIBRARIES}")
MESSAGE("GTK:    ${GTK_LIBRARY_DIRS}")
MESSAGE("GTK:    ${GTK_LDFLAGS}")
MESSAGE("GTK:    ${GTK_LDFLAGS_OTHER}")
MESSAGE("GTK:    ${GTK_CFLAGS}")
MESSAGE("GTK:    ${GTK_CFLAGS_OTHER}")
string(REPLACE "-mfpmath=sse;" "" GTK_CFLAGS_OTHER "${GTK_CFLAGS_OTHER}")
string(REPLACE "-msse;" "" GTK_CFLAGS_OTHER "${GTK_CFLAGS_OTHER}")
string(REPLACE "-msse2;" "" GTK_CFLAGS_OTHER "${GTK_CFLAGS_OTHER}")
string(REPLACE "-mms-bitfields;" "" GTK_CFLAGS_OTHER "${GTK_CFLAGS_OTHER}")
MESSAGE("GTK:    ${GTK_CFLAGS_OTHER}")

PKG_SEARCH_MODULE(PANGOCAIRO REQUIRED pangocairo)
INCLUDE_DIRECTORIES(${PANGOCAIRO_INCLUDE_DIRS})
#MESSAGE("PANGOCAIRO: ${PANGOCAIRO_INCLUDE_DIRS}")

FILE(GLOB commonSource gui/source/*.c
                       gui/source/sketch_area/*.c
                       ctrl/source/*.c
                       data/source/*.c
                       data/source/storage/*.c
                       data/source/set/*.c
                       u8buf/source/utf8stringbuf/*.c
                       u8stream/source/u8stream/*.c
                       u8stream/source/trace/*.c
                       pencil/source/*.c
                       pencil/source/util/geometry/*.c
                       pencil/source/draw/*.c
                       io/source/*.c
                       io/source/image/*.c
                       io/source/json/*.c
                       io/source/xml/*.c
                       io/source/txt/*.c
                       io/source/xhtml/*.c
                       io/source/xmi/*.c
                       io/source/md/*.c)
FILE(GLOB appSource    main/source/*.c)
FILE(GLOB utestSource  main/test/*.c
                       data/test/unit/*.c
                       data/test/integration/*.c
                       ctrl/test/unit/*.c
                       ctrl/test/integration/*.c
                       gui/test/unit/*.c
                       io/test/unit/*.c
                       io/test/integration/*.c
                       pencil/test/unit/*.c
                       pencil/test/integration/*.c
                       u8buf/test/unit/*.c
                       u8stream/test/unit/*.c)

# ==== ==== ==== ==== ==== ==== ==== ==== Check if CMAKE_BUILD_TYPE is set ==== ==== ==== ==== ==== ==== ==== ====

IF(NOT CMAKE_BUILD_TYPE)
  MESSAGE( "Warn: CMAKE_BUILD_TYPE no set!                 setting(CMAKE_BUILD_TYPE \"Release\")")
  SET(CMAKE_BUILD_TYPE "Release")
ENDIF(NOT CMAKE_BUILD_TYPE)
MESSAGE( "Note:                                          CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}" )
MESSAGE( "Note: to build a release, run                  cmake -DCMAKE_BUILD_TYPE=Release " ${CMAKE_CURRENT_SOURCE_DIR} )
MESSAGE( "Note: to build with asserts and traces, run    cmake -DCMAKE_BUILD_TYPE=Debug " ${CMAKE_CURRENT_SOURCE_DIR} )

# ==== ==== ==== ==== ==== ==== ==== ==== Common Settings ==== ==== ==== ==== ==== ==== ==== ====

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11 -D_XOPEN_SOURCE=700 -O2 -pedantic -g -Wall -Wno-overlength-strings ${GTK_CFLAGS_OTHER}" )
# Note: The GIMP-generated images are longer that 4095 characters, therefore -Wno-overlength-strings is required here.

# ==== ==== ==== ==== ==== ==== ==== ==== EXE Target Settings ==== ==== ==== ==== ==== ==== ==== ====

ADD_EXECUTABLE(crystal-facet-uml ${appSource} ${commonSource} ${COMPILE_IN_SOURCE_FILE})
TARGET_LINK_LIBRARIES(crystal-facet-uml ${GTK_LIBRARIES} ${GLIB2_LIBRARIES} ${PANGOCAIRO_LIBRARIES} ${SQLITE3_LIBRARIES} m)
SET_TARGET_PROPERTIES(crystal-facet-uml PROPERTIES LINKER_LANGUAGE C)

# ==== ==== ==== ==== ==== ==== ==== ==== test Target Settings ==== ==== ==== ==== ==== ==== ==== ====

ADD_EXECUTABLE(test_crystal-facet-uml ${utestSource} ${commonSource} ${COMPILE_IN_SOURCE_FILE})
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC test_fw/include)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC data/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC ctrl/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC gui/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC io/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC pencil/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC u8buf/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC u8stream/test)
TARGET_LINK_LIBRARIES(test_crystal-facet-uml ${GTK_LIBRARIES} ${GLIB2_LIBRARIES} ${PANGOCAIRO_LIBRARIES} ${SQLITE3_LIBRARIES} m)
SET_TARGET_PROPERTIES(test_crystal-facet-uml PROPERTIES LINKER_LANGUAGE C)

# ==== ==== ==== ==== ==== ==== ==== ==== Install Settings ==== ==== ==== ==== ==== ==== ==== ====

INSTALL(TARGETS crystal-facet-uml DESTINATION "/usr/bin/")
INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/installation_linux/crystal-facet-uml.desktop" DESTINATION "/usr/share/applications/")
INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/installation_linux/crystal-facet-uml.metainfo.xml" DESTINATION "/usr/share/metainfo/")
INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/gui/source/resources/crystal_facet_uml_80x80.png" DESTINATION "/usr/share/pixmaps/" RENAME "crystal-facet-uml.png")
INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/user_doc/crystal-facet-uml.1.gz" DESTINATION "/usr/share/man/man1/")

# ==== ==== ==== ==== ==== ==== ==== ==== gcov Target Settings ==== ==== ==== ==== ==== ==== ==== ====

if(CFU_ADD_GCOV_TARGET)
    if(CMAKE_COMPILER_IS_GNUCC)
        SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage" )
        SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs" )
        ADD_EXECUTABLE(gcov_crystal-facet-uml ${utestSource} ${commonSource} ${COMPILE_IN_SOURCE_FILE})
        TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC test_fw/include)
        TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC data/test)
        TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC ctrl/test)
        TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC gui/test)
        TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC io/test)
        TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC pencil/test)
        TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC u8buf/test)
        TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC u8stream/test)
        TARGET_LINK_LIBRARIES(gcov_crystal-facet-uml ${GTK_LIBRARIES} ${GLIB2_LIBRARIES} ${PANGOCAIRO_LIBRARIES} ${SQLITE3_LIBRARIES} m)
        SET_TARGET_PROPERTIES(gcov_crystal-facet-uml PROPERTIES LINKER_LANGUAGE C)
        SET_TARGET_PROPERTIES(gcov_crystal-facet-uml PROPERTIES EXCLUDE_FROM_ALL TRUE)
    endif(CMAKE_COMPILER_IS_GNUCC)
endif(CFU_ADD_GCOV_TARGET)


# Copyright 2018-2022 Andreas Warnke
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

=== build/user_doc/Makefile ===
.PHONY: all
all: crystal-facet-uml_documentation.pdf html crystal-facet-uml.1.gz info

SOURCE="../../user_doc"

crystal-facet-uml_documentation.pdf: ../../user_doc/doc/*.xml ../../user_doc/doc/2_feature_gallery_export/*.pdf ../../user_doc/doc/*.pdf ../../user_doc/doc/*.png
	dblatex --type=pdf ${SOURCE}/doc/crystal-facet-uml_documentation.xml --output=./crystal-facet-uml_documentation.pdf

html: ../../user_doc/doc/*.xml ../../user_doc/doc/2_feature_gallery_export/*.png ../../user_doc/doc/*.png
	xmlto --stringparam html.stylesheet=html.css -o ./html/ xhtml ${SOURCE}/doc/crystal-facet-uml_documentation.xml &&\
	echo relocate image files &&\
	cat ${SOURCE}/doc/*.xml | grep -e 'fileref.*png' | sed -e 's/^[^"]*"\([^"]*\)".*/..\/..\/user_doc\/doc\/\1/' | xargs cp --target-directory=./html &&\
	cp ${SOURCE}/doc/html.css ./html &&\
	find ./html -name '*.html' | xargs sed -i -e 's/\.\.\/\.\.\/gui\/source\/resources\///g' &&\
	find ./html -name '*.html' | xargs sed -i -e 's/2_feature_gallery_export\///g'

MAN_STYLESHEET_ROOT=`find /usr/share/xml/docbook/stylesheet -name manpages`
#MAN_STYLESHEET_0="/usr/share/xml/docbook/stylesheet/nwalsh/1.78.1/manpages/docbook.xsl"
#MAN_STYLESHEET_1="/usr/share/xml/docbook/stylesheet/suse/manpages/docbook.xsl"
#MAN_STYLESHEET_2="/usr/share/xml/docbook/stylesheet/docbook-xsl/manpages/docbook.xsl"
MANPAGE_FILE="crystal-facet-uml.1"

crystal-facet-uml.1.gz: ../../user_doc/doc/manpage.xml ../../user_doc/doc/1_non_tech_intro_para.xml ../../user_doc/doc/3_command_line_example_para.xml
	rm -f ${MANPAGE_FILE}.gz ${MAPGAPE_FILE}i &&\
	if [ -e "${MAN_STYLESHEET_ROOT}/docbook.xsl" ] ; then\
	  echo "using ${MAN_STYLESHEET_ROOT}/docbook.xsl ...\n" &&\
	  xsltproc --nonet --param man.charmap.use.subset "0" --xinclude "${MAN_STYLESHEET_ROOT}/docbook.xsl" ${SOURCE}/doc/manpage.xml &&\
	  gzip --quiet ${MANPAGE_FILE} ;\
	else \
	  echo "ERROR: find an appropriate xsl file for the manapge at /usr/share/xml/docbook/stylesheet" ;\
	fi &&\
	echo "to view the output, gunzip --keep ${MANPAGE_FILE}.gz && man --local-file ${MANPAGE_FILE}"

.PHONY: info
info:
	@printf "== call \\e[33;1m make install \\e[0m to update the files in folder ../../user_doc ==\n"

.PHONY: clean
clean:
	rm -f crystal-facet-uml_documentation.pdf &&\
	rm -fr html &&\
	rm -f ${MANPAGE_FILE}.gz

.PHONY: install
install: crystal-facet-uml_documentation.pdf crystal-facet-uml.1.gz
	cp crystal-facet-uml_documentation.pdf ../../user_doc/ &&\
	cp ${MANPAGE_FILE}.gz ../../user_doc/

=== build/win/CMakeLists.txt ===
PROJECT(crystal-facet-uml LANGUAGES C)
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
SET(CMAKE_VERBOSE_MAKEFILE TRUE)

# ==== ==== ==== ==== ==== ==== ==== ==== Build Environment Settings ==== ==== ==== ==== ==== ==== ==== ====

INCLUDE_DIRECTORIES(../../gui/include)
INCLUDE_DIRECTORIES(../../main/include)
INCLUDE_DIRECTORIES(../../ctrl/include)
INCLUDE_DIRECTORIES(../../data/include)
INCLUDE_DIRECTORIES(../../u8buf/include)
INCLUDE_DIRECTORIES(../../pencil/include)
INCLUDE_DIRECTORIES(../../io/include)
INCLUDE_DIRECTORIES(../../u8stream/include)

SET(THIRD_PARTY_ROOT "${CMAKE_CURRENT_SOURCE_DIR}/root")
SET(SQLITE_BASE "${CMAKE_CURRENT_SOURCE_DIR}/root//home/sqlite3")
MESSAGE("THIRD_PARTY_ROOT: ${THIRD_PARTY_ROOT}")

set(ENV{PKG_CONFIG_PATH} "")
set(ENV{PKG_CONFIG_LIBDIR} "${THIRD_PARTY_ROOT}/usr/local/lib/pkgconfig:${THIRD_PARTY_ROOT}/usr/local/lib64/pkgconfig")
set(ENV{PKG_CONFIG_SYSROOT_DIR} "${THIRD_PARTY_ROOT}")
set(PKG_CONFIG_EXECUTABLE "/usr/bin/x86_64-w64-mingw32-pkg-config")
#include(FindPkgConfig)
MESSAGE("ENV{PKG_CONFIG_PATH}:        $ENV{PKG_CONFIG_PATH}")
MESSAGE("ENV{PKG_CONFIG_LIBDIR}:      $ENV{PKG_CONFIG_LIBDIR}")
MESSAGE("ENV{PKG_CONFIG_SYSROOT_DIR}: $ENV{PKG_CONFIG_SYSROOT_DIR}")

INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/cairo")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/gtk-4.0")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/pango-1.0")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/harfbuzz")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/gdk-pixbuf-2.0")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/libxml2")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/libxml2/libxml")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/xkbcommon")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/gio-win32-2.0")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/graphene-1.0")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/libcroco-0.6")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/glib-2.0")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/atk-1.0")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/epoxy")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/fontconfig")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/libpng16")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/fribidi")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/pixman-1")
INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/freetype2")
#INCLUDE_DIRECTORIES("${THIRD_PARTY_ROOT}/usr/local/include/textstyle")

INCLUDE_DIRECTORIES("${SQLITE_BASE}")

FILE(GLOB commonSource ../../gui/source/*.c
                       ../../gui/source/sketch_area/*.c
                       ../../ctrl/source/*.c
                       ../../data/source/*.c
                       ../../data/source/storage/*.c
                       ../../data/source/set/*.c
                       ../../u8buf/source/utf8stringbuf/*.c
                       ../../u8stream/source/u8stream/*.c
                       ../../u8stream/source/trace/*.c
                       ../../pencil/source/*.c
                       ../../pencil/source/util/geometry/*.c
                       ../../pencil/source/draw/*.c
                       ../../io/source/*.c
                       ../../io/source/image/*.c
                       ../../io/source/json/*.c
                       ../../io/source/xml/*.c
                       ../../io/source/txt/*.c
                       ../../io/source/xhtml/*.c
                       ../../io/source/xmi/*.c
                       ../../io/source/md/*.c
                       ${SQLITE_BASE}/sqlite3.c)
FILE(GLOB appSource    ../../main/source/*.c)
FILE(GLOB utestSource  ../../main/test/*.c
                       ../../data/test/unit/*.c
                       ../../data/test/integration/*.c
                       ../../ctrl/test/unit/*.c
                       ../../ctrl/test/integration/*.c
                       ../../gui/test/unit/*.c
                       ../../io/test/unit/*.c
                       ../../io/test/integration/*.c
                       ../../pencil/test/unit/*.c
                       ../../pencil/test/integration/*.c
                       ../../u8buf/test/unit/*.c
                       ../../u8stream/test/unit/*.c)

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs atk
                OUTPUT_VARIABLE ATK_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( ATK_LIB atk-1.0 "${THIRD_PARTY_ROOT}/usr/local/")
MESSAGE("atk found at ${ATK_LIB}")
#pkg_search_module(ATK_LIB REQUIRED atk)
#MESSAGE("atk found at ${ATK_LIB_LIBRARIES} / ${ATK_LIB_INCLUDE_DIRS}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs cairo
                OUTPUT_VARIABLE CAIRO_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( CAIRO_LIB cairo "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("atk found at ${CAIRO_LIB}")
#pkg_search_module(CAIRO_LIB REQUIRED cairo)
#MESSAGE("cairo found at ${CAIRO_LIB_LIBRARIES} / ${CAIRO_LIB_INCLUDE_DIRS}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs fontconfig
                OUTPUT_VARIABLE FONTCNF_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( FONTCNF_LIB fontconfig "${THIRD_PARTY_ROOT}/usr/local/bin/" )
#FIND_LIBRARY( FONTCNF_LIB NAMES "libfontconfig-1.dll" PATHS "${THIRD_PARTY_ROOT}/usr/local/bin" NO_DEFAULT_PATH)
MESSAGE("fontconfig found at ${FONTCNF_LIB}")

set(GAIL_LIB "")
#FIND_LIBRARY( GAIL_LIB gailutil "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("gailutil found at ${GAIL_LIB}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs gdk-pixbuf-2.0
                OUTPUT_VARIABLE GDKPIX_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( GDKPIX_LIB gdk_pixbuf-2.0 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("gdk_pixbuf found at ${GDKPIX_LIB}")

set(GDKWIN_LIB "")
#FIND_LIBRARY( GDKWIN_LIB gdk-win32-3.0 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("gdk-win32 found at ${GDKWIN_LIB}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs gio-2.0
                OUTPUT_VARIABLE GIO_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( GIO_LIB gio-2.0 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("gio-2.0 found at ${GIO_LIB}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs glib-2.0
                OUTPUT_VARIABLE GLIB_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( GLIB_LIB glib-2.0 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("glib-2.0 found at ${GLIB_LIB}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs gmodule-2.0
                OUTPUT_VARIABLE GMOD_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( GMOD_LIB gmodule-2.0 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("gmodule-2.0 found at ${GMOD_LIB}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs gobject-2.0
                OUTPUT_VARIABLE GOBJ_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( GOBJ_LIB gobject-2.0 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("gobject-2.0 found at ${GOBJ_LIB}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs gthread-2.0
                OUTPUT_VARIABLE GTHREAD_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( GTHREAD_LIB gthread-2.0 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("gthread-2.0 found at ${GTHREAD_LIB}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs gtk4
                OUTPUT_VARIABLE GTK_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( GTK_LIB gtk4 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("gtk4 found at ${GTK_LIB}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs pango
                OUTPUT_VARIABLE PANGO_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( PANGO_LIB pango-1.0 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("pango found at ${PANGO_LIB}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs pangocairo
                OUTPUT_VARIABLE PANGOCAIRO_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( PANGOCAIRO_LIB pangocairo-1.0 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("pangocairo found at ${PANGOCAIRO_LIB}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs pangoft2
                OUTPUT_VARIABLE PANGOFT_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( PANGOFT_LIB pangoft2-1.0 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("pangoft2 found at ${PANGOFT_LIB}")

EXECUTE_PROCESS(COMMAND "${PKG_CONFIG_EXECUTABLE}" --libs pangowin32
                OUTPUT_VARIABLE PANGOWIN_LIB OUTPUT_STRIP_TRAILING_WHITESPACE)
#FIND_LIBRARY( PANGOWIN_LIB pangowin32-1.0 "${THIRD_PARTY_ROOT}/usr/local/" )
MESSAGE("pangowin32 found at ${PANGOWIN_LIB}")

# ==== ==== ==== ==== ==== ==== ==== ==== Check if CMAKE_BUILD_TYPE is set ==== ==== ==== ==== ==== ==== ==== ====

IF(NOT CMAKE_BUILD_TYPE)
  MESSAGE( "Warn: CMAKE_BUILD_TYPE no set!                 setting(CMAKE_BUILD_TYPE \"Release\")")
  SET(CMAKE_BUILD_TYPE "Release")
ENDIF(NOT CMAKE_BUILD_TYPE)
MESSAGE( "Note:                                          CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}" )
MESSAGE( "Note:                                          CMAKE_CURRENT_SOURCE_DIR = ${CMAKE_CURRENT_SOURCE_DIR}" )
MESSAGE( "Note:                                          CMAKE_BUILD_DIR = ${CMAKE_BUILD_DIR}" )
MESSAGE( "Note:                                          THIRD_PARTY_ROOT = ${THIRD_PARTY_ROOT}" )
MESSAGE( "Note: to build a release, run                  cmake -DCMAKE_BUILD_TYPE=Release " ${CMAKE_CURRENT_SOURCE_DIR} )
MESSAGE( "Note: to build with asserts and traces, run    cmake -DCMAKE_BUILD_TYPE=Debug " ${CMAKE_CURRENT_SOURCE_DIR} )

# ==== ==== ==== ==== ==== ==== ==== ==== Compiler Settings ==== ==== ==== ==== ==== ==== ==== ====

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11 -D_XOPEN_SOURCE=700 -O2 -pedantic -g -Wall -Wno-overlength-strings -mwindows ${GTK3_CFLAGS_OTHER}" )
# Note: The GIMP-generated images are longer that 4095 characters, therefore -Wno-overlength-strings is required here.
ADD_CUSTOM_COMMAND(
    OUTPUT crystal-facet-uml.res
    COMMAND x86_64-w64-mingw32-windres ${CMAKE_CURRENT_SOURCE_DIR}/crystal-facet-uml.rc -O coff -o crystal-facet-uml.res
)


# ==== ==== ==== ==== ==== ==== ==== ==== C-Code crystal-facet-uml Linker Settings ==== ==== ==== ==== ==== ==== ==== ====

ADD_EXECUTABLE(crystal-facet-uml ${commonSource} ${appSource} crystal-facet-uml.res)
TARGET_LINK_LIBRARIES(crystal-facet-uml ${ATK_LIB} ${CAIRO_LIB} ${FONTCNF_LIB} ${GAIL_LIB} ${GDKPIX_LIB} ${GDKWIN_LIB} ${GIO_LIB} ${GLIB_LIB} ${GMOD_LIB} ${GOBJ_LIB} ${GTHREAD_LIB} ${GTK_LIB} ${PANGO_LIB} ${PANGOCAIRO_LIB} ${PANGOFT_LIB} ${PANGOWIN_LIB} )
SET_TARGET_PROPERTIES(crystal-facet-uml PROPERTIES LINKER_LANGUAGE C)

# ==== ==== ==== ==== ==== ==== ==== ==== Install Settings ==== ==== ==== ==== ==== ==== ==== ====

INSTALL(TARGETS crystal-facet-uml DESTINATION "${THIRD_PARTY_ROOT}/usr/local/bin/")
INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../../installation_win/crystal-facet-uml.bat" DESTINATION "${THIRD_PARTY_ROOT}/usr/local/")
INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../../installation_win/crystal-facet-uml_readme.txt" DESTINATION "${THIRD_PARTY_ROOT}/usr/local/")

# ==== ==== ==== ==== ==== ==== ==== ==== test Settings ==== ==== ==== ==== ==== ==== ==== ====

ADD_EXECUTABLE(test_crystal-facet-uml ${commonSource} ${utestSource})
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC ../../test_fw/include)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC ../../data/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC ../../ctrl/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC ../../gui/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC ../../io/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC ../../pencil/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC ../../u8buf/test)
TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC ../../u8stream/test)

=== debian/changelog ===
crystal-facet-uml (1.38.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.6.1. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 12 Jun 2022 15:04:44 +0200

=== debian/control ===
Source: crystal-facet-uml
Section: devel
Priority: optional
Maintainer: Andreas Warnke <cfu@andreaswarnke.de>
Uploaders:
 Debian Edu Packaging Team <debian-edu-pkg-team@lists.alioth.debian.org>,
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libgtk-3-dev,
 libsqlite3-dev,
Standards-Version: 4.6.1
Homepage: https://andreaswarnke.de/crystal-facet-uml/html/index.html
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian-edu-pkg-team/crystal-facet-uml.git
Vcs-Browser: https://salsa.debian.org/debian-edu-pkg-team/crystal-facet-uml/

Package: crystal-facet-uml
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Diagram documentation tool for system and software architecture:
 crystal-facet-uml creates sysml/uml diagrams to document system and
 software architecture.
 .
 As software architect, you create a set of diagrams describing
 use-cases, requirements, structural views, behavioral and deployment
 views. crystal-facet-uml keeps element names and element hierarchies
 consistent. It exports diagrams in svg, pdf, ps and png formats to be
 used in text processing systems like DocBook, html, LaTeX.
 crystal-facet-uml exports the model to xmi format.
 This tool runs on your local PC and is based on
 glib, gdk, gtk, cairo, pango, sqlite.

## crystal-facet-uml 1.42.0

=== debian/changelog ===
crystal-facet-uml (1.42.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/source/lintian-overrides:
    + Adjust override tag.
  * debian/patches:
    + Add 1001_typo-fix.patch.
  * debian/copyright:
    + Update copyright attributions for debian/*.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 11 Oct 2022 08:51:28 +0200

## crystal-facet-uml 1.43.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 PROJECT(crystal-facet-uml LANGUAGES C)
 CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
 
-#helper to find include directories and libraries:
+# pkgconfig is a helper program to find include directories and libraries:
 FIND_PACKAGE(PkgConfig REQUIRED)
 
 # ==== ==== ==== ==== ==== ==== ==== ==== Build Environment Settings ==== ==== ==== ==== ==== ==== ==== ====
@@ -32,8 +32,13 @@
 INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
 #MESSAGE("GLIB2:   ${GLIB2_INCLUDE_DIRS}")
 
-PKG_SEARCH_MODULE(GTK REQUIRED gtk+-3.0)
-#PKG_SEARCH_MODULE(GTK REQUIRED gtk4)
+#install gtk4 and call cmake -DCFU_USE_GTK4=ON . to activate GTK4
+SET(CFU_USE_GTK4 FALSE CACHE BOOL "Set to link to the new GTK4")
+if(CFU_USE_GTK4)
+    PKG_SEARCH_MODULE(GTK REQUIRED gtk4)
+else(CFU_USE_GTK4)
+    PKG_SEARCH_MODULE(GTK REQUIRED gtk+-3.0)
+endif(CFU_USE_GTK4)
 INCLUDE_DIRECTORIES(${GTK_INCLUDE_DIRS})
 MESSAGE("GTK:    ${GTK_INCLUDE_DIRS}")
 MESSAGE("GTK:    ${GTK_FOUND}")
@@ -54,16 +59,17 @@
 #MESSAGE("PANGOCAIRO: ${PANGOCAIRO_INCLUDE_DIRS}")
 
 FILE(GLOB commonSource gui/source/*.c
-                       gui/source/sketch_area/*.c
+                       gui/source/sketch/*.c
                        ctrl/source/*.c
                        data/source/*.c
                        data/source/storage/*.c
                        data/source/set/*.c
                        u8buf/source/utf8stringbuf/*.c
+                       u8stream/source/dir/*.c
                        u8stream/source/u8stream/*.c
                        u8stream/source/trace/*.c
                        pencil/source/*.c
-                       pencil/source/util/geometry/*.c
+                       pencil/source/geometry/*.c
                        pencil/source/draw/*.c
                        io/source/*.c
                        io/source/image/*.c

=== build/user_doc/Makefile ===
--- 
+++ 
@@ -4,9 +4,11 @@
 SOURCE="../../user_doc"
 
 crystal-facet-uml_documentation.pdf: ../../user_doc/doc/*.xml ../../user_doc/doc/2_feature_gallery_export/*.pdf ../../user_doc/doc/*.pdf ../../user_doc/doc/*.png
+	echo "PLEASE UPDATE DIAGRAMS IN ../../user_doc/doc/2_feature_gallery_export/ MANUALLY" &&\
 	dblatex --type=pdf ${SOURCE}/doc/crystal-facet-uml_documentation.xml --output=./crystal-facet-uml_documentation.pdf
 
 html: ../../user_doc/doc/*.xml ../../user_doc/doc/2_feature_gallery_export/*.png ../../user_doc/doc/*.png
+	echo "PLEASE UPDATE DIAGRAMS IN ../../user_doc/doc/2_feature_gallery_export/ MANUALLY" &&\
 	xmlto --stringparam html.stylesheet=html.css -o ./html/ xhtml ${SOURCE}/doc/crystal-facet-uml_documentation.xml &&\
 	echo relocate image files &&\
 	cat ${SOURCE}/doc/*.xml | grep -e 'fileref.*png' | sed -e 's/^[^"]*"\([^"]*\)".*/..\/..\/user_doc\/doc\/\1/' | xargs cp --target-directory=./html &&\

=== debian/changelog ===
crystal-facet-uml (1.43.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 1001_typo-fix.patch. Applied upstream.
  * debian/copyright:
    + Update copyright attributions.
  * debian/source/lintian-overrides:
    + Drop file. Override not required anymore.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 06 Nov 2022 22:20:32 +0100

## crystal-facet-uml 1.45.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -67,7 +67,7 @@
                        u8buf/source/utf8stringbuf/*.c
                        u8stream/source/dir/*.c
                        u8stream/source/u8stream/*.c
-                       u8stream/source/trace/*.c
+                       u8stream/source/u8/*.c
                        pencil/source/*.c
                        pencil/source/geometry/*.c
                        pencil/source/draw/*.c

=== build/user_doc/Makefile ===
--- 
+++ 
@@ -22,7 +22,7 @@
 #MAN_STYLESHEET_2="/usr/share/xml/docbook/stylesheet/docbook-xsl/manpages/docbook.xsl"
 MANPAGE_FILE="crystal-facet-uml.1"
 
-crystal-facet-uml.1.gz: ../../user_doc/doc/manpage.xml ../../user_doc/doc/1_non_tech_intro_para.xml ../../user_doc/doc/3_command_line_example_para.xml
+crystal-facet-uml.1.gz: ../../user_doc/doc/manpage.xml ../../user_doc/doc/1_non_tech_intro_para.xml ../../user_doc/doc/6_command_line_example_para.xml
 	rm -f ${MANPAGE_FILE}.gz ${MAPGAPE_FILE}i &&\
 	if [ -e "${MAN_STYLESHEET_ROOT}/docbook.xsl" ] ; then\
 	  echo "using ${MAN_STYLESHEET_ROOT}/docbook.xsl ...\n" &&\

=== debian/changelog ===
crystal-facet-uml (1.45.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 14 Jan 2023 21:45:29 +0100

## crystal-facet-uml 1.46.0

=== debian/changelog ===
crystal-facet-uml (1.46.0-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 03 Feb 2023 11:06:10 +0100

## crystal-facet-uml 1.47.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -65,7 +65,7 @@
                        data/source/storage/*.c
                        data/source/set/*.c
                        u8buf/source/utf8stringbuf/*.c
-                       u8stream/source/dir/*.c
+                       u8stream/source/u8dir/*.c
                        u8stream/source/u8stream/*.c
                        u8stream/source/u8/*.c
                        pencil/source/*.c
@@ -158,7 +158,7 @@
 endif(CFU_ADD_GCOV_TARGET)
 
 
-# Copyright 2018-2022 Andreas Warnke
+# Copyright 2018-2023 Andreas Warnke
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.

=== build/user_manual/Makefile ===
.PHONY: all
all: crystal-facet-uml_documentation.pdf html crystal-facet-uml.1.gz info

SOURCE=../../documentation/user_manual

crystal-facet-uml_documentation.pdf: ${SOURCE}/*.xml ${SOURCE}/2_feature_gallery_export/*.pdf ${SOURCE}/*.pdf ${SOURCE}/*.png
	echo "PLEASE UPDATE DIAGRAMS IN ../../user_doc/doc/2_feature_gallery_export/ MANUALLY" &&\
	dblatex --type=pdf ${SOURCE}/crystal-facet-uml_documentation.xml --output=./crystal-facet-uml_documentation.pdf

html: ${SOURCE}/*.xml ${SOURCE}/2_feature_gallery_export/*.png ${SOURCE}/*.png
	echo "PLEASE UPDATE DIAGRAMS IN ${SOURCE}/2_feature_gallery_export/ MANUALLY" &&\
	xmlto --stringparam html.stylesheet=html.css -o ./html/ xhtml ${SOURCE}/crystal-facet-uml_documentation.xml &&\
	echo relocate image files &&\
	cat ${SOURCE}/*.xml | grep -e 'fileref.*png' | sed -e 's#^[^"]*"\([^"]*\)".*#${SOURCE}/\1#' | xargs cp --target-directory=./html &&\
	cp ${SOURCE}/html.css ./html &&\
	find ./html -name '*.html' | xargs sed -i -e 's/\.\.\/\.\.\/gui\/source\/resources\///g' &&\
	find ./html -name '*.html' | xargs sed -i -e 's/2_feature_gallery_export\///g'

MAN_STYLESHEET_ROOT=`find /usr/share/xml/docbook/stylesheet -name manpages`
#MAN_STYLESHEET_0="/usr/share/xml/docbook/stylesheet/nwalsh/1.78.1/manpages/docbook.xsl"
#MAN_STYLESHEET_1="/usr/share/xml/docbook/stylesheet/suse/manpages/docbook.xsl"
#MAN_STYLESHEET_2="/usr/share/xml/docbook/stylesheet/docbook-xsl/manpages/docbook.xsl"
MANPAGE_FILE="crystal-facet-uml.1"

crystal-facet-uml.1.gz: ${SOURCE}/manpage.xml ${SOURCE}/1_non_tech_intro_para.xml ${SOURCE}/6_command_line_example_para.xml
	rm -f ${MANPAGE_FILE}.gz ${MAPGAPE_FILE}i &&\
	if [ -e "${MAN_STYLESHEET_ROOT}/docbook.xsl" ] ; then\
	  echo "using ${MAN_STYLESHEET_ROOT}/docbook.xsl ...\n" &&\
	  xsltproc --nonet --param man.charmap.use.subset "0" --xinclude "${MAN_STYLESHEET_ROOT}/docbook.xsl" ${SOURCE}/manpage.xml &&\
	  gzip --quiet ${MANPAGE_FILE} ;\
	else \
	  echo "ERROR: find an appropriate xsl file for the manapge at /usr/share/xml/docbook/stylesheet" ;\
	fi &&\
	echo "to view the output, gunzip --keep ${MANPAGE_FILE}.gz && man --local-file ${MANPAGE_FILE}"

.PHONY: info
info:
	@printf "== call \\e[33;1m make install \\e[0m to update the files in folder ../../user_doc ==\n"

.PHONY: clean
clean:
	rm -f crystal-facet-uml_documentation.pdf &&\
	rm -fr html &&\
	rm -f ${MANPAGE_FILE}.gz

.PHONY: install
install: crystal-facet-uml_documentation.pdf crystal-facet-uml.1.gz
	cp crystal-facet-uml_documentation.pdf ../../user_doc/ &&\
	cp ${MANPAGE_FILE}.gz ../../user_doc/


# Copyright 2021-2023 Andreas Warnke
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

=== debian/changelog ===
crystal-facet-uml (1.47.0-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 26 Feb 2023 22:57:51 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  debhelper-compat (= 13),
  libgtk-3-dev,
  libsqlite3-dev,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://andreaswarnke.de/crystal-facet-uml/html/index.html
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian-edu-pkg-team/crystal-facet-uml.git

## crystal-facet-uml 1.50.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,6 @@
 INCLUDE_DIRECTORIES(main/include)
 INCLUDE_DIRECTORIES(ctrl/include)
 INCLUDE_DIRECTORIES(data/include)
-INCLUDE_DIRECTORIES(u8buf/include)
 INCLUDE_DIRECTORIES(pencil/include)
 INCLUDE_DIRECTORIES(io/include)
 INCLUDE_DIRECTORIES(u8stream/include)
@@ -64,7 +63,7 @@
                        data/source/*.c
                        data/source/storage/*.c
                        data/source/set/*.c
-                       u8buf/source/utf8stringbuf/*.c
+                       u8stream/source/utf8stringbuf/*.c
                        u8stream/source/u8dir/*.c
                        u8stream/source/u8stream/*.c
                        u8stream/source/u8/*.c
@@ -90,7 +89,6 @@
                        io/test/integration/*.c
                        pencil/test/unit/*.c
                        pencil/test/integration/*.c
-                       u8buf/test/unit/*.c
                        u8stream/test/unit/*.c)
 
 # ==== ==== ==== ==== ==== ==== ==== ==== Check if CMAKE_BUILD_TYPE is set ==== ==== ==== ==== ==== ==== ==== ====
@@ -123,7 +121,6 @@
 TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC gui/test)
 TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC io/test)
 TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC pencil/test)
-TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC u8buf/test)
 TARGET_INCLUDE_DIRECTORIES(test_crystal-facet-uml PUBLIC u8stream/test)
 TARGET_LINK_LIBRARIES(test_crystal-facet-uml ${GTK_LIBRARIES} ${GLIB2_LIBRARIES} ${PANGOCAIRO_LIBRARIES} ${SQLITE3_LIBRARIES} m)
 SET_TARGET_PROPERTIES(test_crystal-facet-uml PROPERTIES LINKER_LANGUAGE C)
@@ -149,7 +146,6 @@
         TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC gui/test)
         TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC io/test)
         TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC pencil/test)
-        TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC u8buf/test)
         TARGET_INCLUDE_DIRECTORIES(gcov_crystal-facet-uml PUBLIC u8stream/test)
         TARGET_LINK_LIBRARIES(gcov_crystal-facet-uml ${GTK_LIBRARIES} ${GLIB2_LIBRARIES} ${PANGOCAIRO_LIBRARIES} ${SQLITE3_LIBRARIES} m)
         SET_TARGET_PROPERTIES(gcov_crystal-facet-uml PROPERTIES LINKER_LANGUAGE C)

=== build/user_manual/Makefile ===
--- 
+++ 
@@ -3,16 +3,18 @@
 
 SOURCE=../../documentation/user_manual
 
-crystal-facet-uml_documentation.pdf: ${SOURCE}/*.xml ${SOURCE}/2_feature_gallery_export/*.pdf ${SOURCE}/*.pdf ${SOURCE}/*.png
+crystal-facet-uml_documentation.pdf: ${SOURCE}/*.xml ${SOURCE}/2_feature_gallery_export/*.pdf ${SOURCE}/*.pdf ${SOURCE}/*.png ${SOURCE}/4_stereotypes/*.*
+	echo "you may need to install sudo zypper install rsvg-convert" &&\
 	echo "PLEASE UPDATE DIAGRAMS IN ../../user_doc/doc/2_feature_gallery_export/ MANUALLY" &&\
 	dblatex --type=pdf ${SOURCE}/crystal-facet-uml_documentation.xml --output=./crystal-facet-uml_documentation.pdf
 
-html: ${SOURCE}/*.xml ${SOURCE}/2_feature_gallery_export/*.png ${SOURCE}/*.png
+html: ${SOURCE}/*.xml ${SOURCE}/2_feature_gallery_export/*.png ${SOURCE}/*.png ${SOURCE}/4_stereotypes/*.*
 	echo "PLEASE UPDATE DIAGRAMS IN ${SOURCE}/2_feature_gallery_export/ MANUALLY" &&\
 	xmlto --stringparam html.stylesheet=html.css -o ./html/ xhtml ${SOURCE}/crystal-facet-uml_documentation.xml &&\
 	echo relocate image files &&\
 	cat ${SOURCE}/*.xml | grep -e 'fileref.*png' | sed -e 's#^[^"]*"\([^"]*\)".*#${SOURCE}/\1#' | xargs cp --target-directory=./html &&\
 	cp ${SOURCE}/html.css ./html &&\
+	cp ${SOURCE}/4_stereotypes/*.svg ./html &&\
 	find ./html -name '*.html' | xargs sed -i -e 's/\.\.\/\.\.\/gui\/source\/resources\///g' &&\
 	find ./html -name '*.html' | xargs sed -i -e 's/2_feature_gallery_export\///g'

=== debian/changelog ===
crystal-facet-uml (1.50.1-1) unstable; urgency=medium

  * New upstream release.
    - The gcov target is only built if -DCFU_ADD_GCOV_TARGET=ON (Closes:
      #983836). (OFF by default).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 19 Jun 2023 06:35:09 +0200

## crystal-facet-uml 1.54.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -58,8 +58,10 @@
 #MESSAGE("PANGOCAIRO: ${PANGOCAIRO_INCLUDE_DIRS}")
 
 FILE(GLOB commonSource gui/source/*.c
+                       gui/source/attributes/*.c
                        gui/source/sketch/*.c
                        ctrl/source/*.c
+                       ctrl/source/consistency/*.c
                        data/source/*.c
                        data/source/storage/*.c
                        data/source/set/*.c
@@ -75,7 +77,7 @@
                        io/source/json/*.c
                        io/source/xml/*.c
                        io/source/txt/*.c
-                       io/source/xhtml/*.c
+                       io/source/document/*.c
                        io/source/xmi/*.c
                        io/source/md/*.c)
 FILE(GLOB appSource    main/source/*.c)

=== build/user_manual/Makefile ===
--- 
+++ 
@@ -1,22 +1,24 @@
 .PHONY: all
-all: crystal-facet-uml_documentation.pdf html crystal-facet-uml.1.gz info
+all: html crystal-facet-uml_documentation.pdf crystal-facet-uml.1.gz info
 
 SOURCE=../../documentation/user_manual
 
-crystal-facet-uml_documentation.pdf: ${SOURCE}/*.xml ${SOURCE}/2_feature_gallery_export/*.pdf ${SOURCE}/*.pdf ${SOURCE}/*.png ${SOURCE}/4_stereotypes/*.*
-	echo "you may need to install sudo zypper install rsvg-convert" &&\
+crystal-facet-uml_documentation.pdf: ${SOURCE}/*.xml ${SOURCE}/2_feature_gallery_export/*.pdf ${SOURCE}/*.svg ${SOURCE}/*.png ${SOURCE}/4_stereotypes/*.* ${SOURCE}/5_modeling_hints_export/*.svg
+	echo "you may need to install sudo zypper install rsvg-convert or sudo apt install librsvg2-bin" &&\
 	echo "PLEASE UPDATE DIAGRAMS IN ../../user_doc/doc/2_feature_gallery_export/ MANUALLY" &&\
-	dblatex --type=pdf ${SOURCE}/crystal-facet-uml_documentation.xml --output=./crystal-facet-uml_documentation.pdf
+	dblatex -c use_rsvg-convert.conf --type=pdf ${SOURCE}/crystal-facet-uml_documentation.xml --output=./crystal-facet-uml_documentation.pdf
 
-html: ${SOURCE}/*.xml ${SOURCE}/2_feature_gallery_export/*.png ${SOURCE}/*.png ${SOURCE}/4_stereotypes/*.*
+html: ${SOURCE}/*.xml ${SOURCE}/2_feature_gallery_export/*.png ${SOURCE}/*.png ${SOURCE}/*.svg ${SOURCE}/4_stereotypes/*.*
 	echo "PLEASE UPDATE DIAGRAMS IN ${SOURCE}/2_feature_gallery_export/ MANUALLY" &&\
 	xmlto --stringparam html.stylesheet=html.css -o ./html/ xhtml ${SOURCE}/crystal-facet-uml_documentation.xml &&\
 	echo relocate image files &&\
 	cat ${SOURCE}/*.xml | grep -e 'fileref.*png' | sed -e 's#^[^"]*"\([^"]*\)".*#${SOURCE}/\1#' | xargs cp --target-directory=./html &&\
+	cat ${SOURCE}/*.xml | grep -e 'fileref.*svg' | sed -e 's#^[^"]*"\([^"]*\)".*#${SOURCE}/\1#' | xargs cp --target-directory=./html &&\
 	cp ${SOURCE}/html.css ./html &&\
 	cp ${SOURCE}/4_stereotypes/*.svg ./html &&\
 	find ./html -name '*.html' | xargs sed -i -e 's/\.\.\/\.\.\/gui\/source\/resources\///g' &&\
 	find ./html -name '*.html' | xargs sed -i -e 's/2_feature_gallery_export\///g'
+	find ./html -name '*.html' | xargs sed -i -e 's/5_modeling_hints_export\///g'
 
 MAN_STYLESHEET_ROOT=`find /usr/share/xml/docbook/stylesheet -name manpages`
 #MAN_STYLESHEET_0="/usr/share/xml/docbook/stylesheet/nwalsh/1.78.1/manpages/docbook.xsl"

=== debian/changelog ===
crystal-facet-uml (1.54.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 26 Dec 2023 09:49:10 +0100

## crystal-facet-uml 1.55.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 #MESSAGE("GLIB2:   ${GLIB2_INCLUDE_DIRS}")
 
 #install gtk4 and call cmake -DCFU_USE_GTK4=ON . to activate GTK4
-SET(CFU_USE_GTK4 FALSE CACHE BOOL "Set to link to the new GTK4")
+SET(CFU_USE_GTK4 TRUE CACHE BOOL "Set to link to the new GTK4")
 if(CFU_USE_GTK4)
     PKG_SEARCH_MODULE(GTK REQUIRED gtk4)
 else(CFU_USE_GTK4)
@@ -75,11 +75,9 @@
                        io/source/*.c
                        io/source/image/*.c
                        io/source/json/*.c
-                       io/source/xml/*.c
-                       io/source/txt/*.c
                        io/source/document/*.c
                        io/source/xmi/*.c
-                       io/source/md/*.c)
+                       io/source/format/*.c)
 FILE(GLOB appSource    main/source/*.c)
 FILE(GLOB utestSource  main/test/*.c
                        data/test/unit/*.c
@@ -130,10 +128,10 @@
 # ==== ==== ==== ==== ==== ==== ==== ==== Install Settings ==== ==== ==== ==== ==== ==== ==== ====
 
 INSTALL(TARGETS crystal-facet-uml DESTINATION "/usr/bin/")
-INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/installation_linux/crystal-facet-uml.desktop" DESTINATION "/usr/share/applications/")
-INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/installation_linux/crystal-facet-uml.metainfo.xml" DESTINATION "/usr/share/metainfo/")
+INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/installation/linux/crystal-facet-uml.desktop" DESTINATION "/usr/share/applications/")
+INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/installation/linux/crystal-facet-uml.metainfo.xml" DESTINATION "/usr/share/metainfo/")
 INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/gui/source/resources/crystal_facet_uml_80x80.png" DESTINATION "/usr/share/pixmaps/" RENAME "crystal-facet-uml.png")
-INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/user_doc/crystal-facet-uml.1.gz" DESTINATION "/usr/share/man/man1/")
+INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/installation/linux/crystal-facet-uml.1.gz" DESTINATION "/usr/share/man/man1/")
 
 # ==== ==== ==== ==== ==== ==== ==== ==== gcov Target Settings ==== ==== ==== ==== ==== ==== ==== ====
 
@@ -156,7 +154,7 @@
 endif(CFU_ADD_GCOV_TARGET)
 
 
-# Copyright 2018-2023 Andreas Warnke
+# Copyright 2018-2024 Andreas Warnke
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -169,4 +167,3 @@
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and
 # limitations under the License.
-

=== build/user_manual/Makefile ===
--- 
+++ 
@@ -39,7 +39,7 @@
 
 .PHONY: info
 info:
-	@printf "== call \\e[33;1m make install \\e[0m to update the files in folder ../../user_doc ==\n"
+	@printf "== call \\e[33;1m make install \\e[0m to update the files in folder ../../installation ==\n"
 
 .PHONY: clean
 clean:
@@ -49,11 +49,11 @@
 
 .PHONY: install
 install: crystal-facet-uml_documentation.pdf crystal-facet-uml.1.gz
-	cp crystal-facet-uml_documentation.pdf ../../user_doc/ &&\
-	cp ${MANPAGE_FILE}.gz ../../user_doc/
+	cp crystal-facet-uml_documentation.pdf ../../installation/ &&\
+	cp ${MANPAGE_FILE}.gz ../../installation/linux/
 
 
-# Copyright 2021-2023 Andreas Warnke
+# Copyright 2021-2024 Andreas Warnke
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -66,4 +66,3 @@
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and
 # limitations under the License.
-

=== debian/changelog ===
crystal-facet-uml (1.55.3-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:42:09 +1100

crystal-facet-uml (1.55.3-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 04:09:09 +0000

crystal-facet-uml (1.55.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 12 Feb 2024 18:58:20 +0100

crystal-facet-uml (1.55.0-1) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/copyright:
    + Update copyright attribution for debian/.

  [ Andreas Warnke ]
  * New upstream release.
  * debian/:
    + Switch to Gtk-4.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 11 Feb 2024 18:20:15 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: crystal-facet-uml
 Section: devel
 Priority: optional
-Maintainer: Andreas Warnke <cfu@andreaswarnke.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andreas Warnke <cfu@andreaswarnke.de>
 Uploaders:
  Debian Edu Packaging Team <debian-edu-pkg-team@lists.alioth.debian.org>,
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
- libgtk-3-dev,
+ libgtk-4-dev,
  libsqlite3-dev,
 Standards-Version: 4.6.2
 Homepage: https://andreaswarnke.de/crystal-facet-uml/html/index.html
@@ -30,6 +31,8 @@
  views. crystal-facet-uml keeps element names and element hierarchies
  consistent. It exports diagrams in svg, pdf, ps and png formats to be
  used in text processing systems like DocBook, html, LaTeX.
- crystal-facet-uml exports the model to xmi format.
+ crystal-facet-uml exports the model to json and xmi format; json can
+ also be imported. The json-based data format can be stored to git,
+ branched and merged together with your source code.
  This tool runs on your local PC and is based on
- glib, gdk, gtk, cairo, pango, sqlite.
+ gtk (incl. glib, gdk, cairo, pango) and sqlite.
